// WndSMSRecvList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "WndSMSRecvList.h"


// CWndSMSRecvList

IMPLEMENT_DYNAMIC(CWndSMSRecvList, CWnd)

CWndSMSRecvList::CWndSMSRecvList()
{
	m_pImgDelete = NULL;
	m_pImgDeleteOver = NULL;

	m_crBG = WND_SMSRECV_LIST_BG_COLOR;
	m_crBGOutline = WND_SMSRECV_LIST_BORDER_COLOR;
	m_crItemBG = WND_SMSRECV_LIST_ITEM_BG_COLOR;
	m_crItemOutline = WND_SMSRECV_LIST_ITEM_BORDER_COLOR;
	m_crItemBGHighlight = WND_SMSRECV_LIST_ITEM_HIGHLIGHT_COLOR;
	m_crItemOutlineHighlight = WND_SMSRECV_LIST_ITEM_HIGHLIGHT_BORDER_COLOR;


	m_nScrollPageSize = 
	// font
    _tcscpy_s(m_wszFontName, GetDefaultFontFaceName());// DEF_USERMGR_ITEM_FONT_NAME);
	m_nFontHeight = DEF_USERMGR_ITEM_FONT_HEIGHT;
	m_fontStyle = DEF_USERMGR_ITEM_FONT_STYLE;
	m_crText = WND_SMSRECV_LIST_FONT_COLOR;
	m_nScrollOneSize =25;
	
	ClearUserMgrItemAll();
}

CWndSMSRecvList::~CWndSMSRecvList()
{
	ClearUserMgrItemAll();
}


BEGIN_MESSAGE_MAP(CWndSMSRecvList, CWnd)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSELEAVE()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_MOUSEWHEEL()
	ON_WM_VSCROLL()
	ON_MESSAGE(WM_SMSDLG_RECEIVERLIST_ADDUSER ,OnAddUser)
	ON_MESSAGE(WM_SMSDLG_RECEIVERLIST_ADDUSER_FAIL, OnAddFail)
END_MESSAGE_MAP()


BOOL CWndSMSRecvList::OnEraseBkgnd(CDC* pDC)
{
	return FALSE;
}

void CWndSMSRecvList::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;

    CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	HDC hdc = dc.GetSafeHdc();
	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, rcClient.Width(), rcClient.Height());
	
	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		UtilFillSolidRect(hdcMemory,rcClient,RGB(255,255,255));
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		Image* pImg = NULL, *pImgDelete = NULL;
		SolidBrush brushItem(m_crItemBG);
		Pen penItem(m_crItemOutline, 1);

		int nCntItem = m_ptrArrayItem.GetCount();
		USER_ITEM_INFO* pUMInfo = NULL;

		//ũѹ   ġ  .
		//
		if (nCntItem >0)
		{
			pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(0);
			if (pUMInfo->rtItem.top == 0)
			{
				for (int i = 0; i < nCntItem; i++)
				{
					pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
					pUMInfo->rtItem.OffsetRect(0,5);
					pUMInfo->rtName.OffsetRect(0,5);
					pUMInfo->rtDelete.OffsetRect(0,5);
				}

			}
		}
		
	
		for (int i = 0; i < nCntItem; i++)
		{
			pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
			if (!pUMInfo)
				continue;

			int nSX;
			int nSY;
			int nCX;
			int nCY;

			nSX = pUMInfo->rtItem.left;// - rtPS.left;
			nSY = pUMInfo->rtItem.top;// - rtPS.top;
			nCX = pUMInfo->rtItem.Width();
			nCY = pUMInfo->rtItem.Height();

			CRect rcIndexNum(0, 0, 0, 0);
			//ܰ ʹ پ 2ȼ ش.
			rcIndexNum.SetRect(2,nSY + 2,30,nSY+nCY);

			brushItem.SetColor(m_crItemBG);
			penItem.SetColor(m_crItemOutline);
			if (pUMInfo->bDown)
			{
				brushItem.SetColor(m_crItemBGHighlight);
				penItem.SetColor(m_crItemOutlineHighlight);
			}
			graph.FillRectangle(&brushItem, nSX, nSY, nCX, nCY - 1);

			CString strIndexNum;
			strIndexNum.Format(L"%d.",pUMInfo->nIndex);
			DrawTextToDest2(&graph,
				strIndexNum, &rcClient, &rcIndexNum,
				m_wszFontName, m_nFontHeight,
				StringAlignmentNear,
				m_fontStyle,
				m_crText);



			if (!(pUMInfo->strName.IsEmpty()))
			{
				CRect rtName = pUMInfo->rtName;
				rtName.InflateRect(0, 0, 5, 0);
				rtName.OffsetRect(0, 1);
				if (pUMInfo->strName == pUMInfo->strTelNum)
					DrawTextToDest2(&graph, pUMInfo->strTelNum, &rcClient, &rtName,	m_wszFontName, m_nFontHeight, StringAlignmentNear,	m_fontStyle, m_crText);
				else
					DrawTextToDest2(&graph,	pUMInfo->strName +L" (" + pUMInfo->strTelNum + L")", &rcClient, &rtName,	m_wszFontName, m_nFontHeight, StringAlignmentNear, m_fontStyle,	m_crText);
			}
			pImgDelete = m_pImgDelete;
			if (pUMInfo->bHoverDelete || pUMInfo->bDownDelete)
				pImgDelete = m_pImgDeleteOver;
			if (pImgDelete)
				DrawImageToDest(&graph, pImgDelete, &rcClient, &(pUMInfo->rtDelete), &ImgAttr);

			graph.DrawRectangle(&penItem, nSX, nSY, nCX, nCY - 1);
		}

		BitBlt(dc.GetSafeHdc(), 0, 0, rcClient.Width(), rcClient.Height(), hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);

}

void CWndSMSRecvList::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CWnd::OnLButtonDblClk(nFlags, point);
}

void CWndSMSRecvList::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();

	int nCntItem = m_ptrArrayItem.GetCount();
	if (nCntItem <= 0)
		return;

	CWnd* pWndParent = GetParent();

	USER_ITEM_INFO* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo->bDownDelete && pUMInfo->rtDelete.PtInRect(point))
		{
			if (pWndParent && pWndParent->GetSafeHwnd())
				pWndParent->SendMessage(WM_SMSDLG_RECEIVERLIST_DELUSER, (WPARAM)0, (LPARAM)pUMInfo);
			DeleteUserMgrItem(pUMInfo);
			return;
		}
		else if (pUMInfo->bDown && pUMInfo->rtItem.PtInRect(point))
		{
		}
		pUMInfo->bDownDelete = FALSE;
	}
	CWnd::OnLButtonUp(nFlags, point);
}

void CWndSMSRecvList::OnLButtonDown(UINT nFlags, CPoint point)
{

	int nCntItem = m_ptrArrayItem.GetCount();
	if (nCntItem <= 0)
		return;

	BOOL bUpdate = FALSE;
	CRect rtUpdate(0, 0, 0, 0);

	BOOL bDownDelete = FALSE;
	USER_ITEM_INFO* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pUMInfo)
			continue;

		pUMInfo->bDownDelete = FALSE;
		if (pUMInfo->rtDelete.PtInRect(point))
		{
			pUMInfo->bDownDelete = TRUE;
			bDownDelete = TRUE;
		}
	}
	if (!bDownDelete)
	{
		for (int i = 0; i < nCntItem; i++)
		{
			pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
			if (!pUMInfo)
				continue;

			BOOL bDown = FALSE;
			if (pUMInfo->rtItem.PtInRect(point))
			{
				bDown = TRUE;
			}

			if (pUMInfo->bDown != bDown)
			{
				pUMInfo->bDown = bDown;
				rtUpdate.UnionRect(&rtUpdate, &(pUMInfo->rtItem));
				rtUpdate.InflateRect(1, 1);
				if (!bUpdate)
					SetCapture();

				bUpdate = TRUE;
			}
		}
	}
	if (bUpdate)
		RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);


	CWnd::OnLButtonDown(nFlags, point);
}

void CWndSMSRecvList::OnMouseMove(UINT nFlags, CPoint point)
{
	CWnd::OnMouseMove(nFlags, point);
}

void CWndSMSRecvList::OnMouseLeave()
{
	CWnd::OnMouseLeave();
}

int CWndSMSRecvList::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndScrollBar.Create(WS_CHILD | SBS_VERT, CRect(0, 0, 0, 0), this, ID_RECV_SCROLLBAR))
		return -1;
	
	
	

	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(m_wndScrollBar.GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	//pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
	

	return 0;
}

void CWndSMSRecvList::SetImgBGPath( CString strFileName )
{

}

void CWndSMSRecvList::SetImgDeletePath( CString strFileName, CString strFileNameOver )
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgDelete = new Image(strImgPath);

	if (strFileNameOver.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameOver);

	m_pImgDeleteOver = new Image(strImgPath);
}

void CWndSMSRecvList::SetFontConfig( WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText )
{

}

void CWndSMSRecvList::ClearUserMgrItemAll()
{
	USER_ITEM_INFO* pUseItemInfo = NULL;
	for (int i = 0; i < m_ptrArrayItem.GetCount(); i++)
	{
		pUseItemInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pUseItemInfo)
			continue;
		delete pUseItemInfo;
	}
	m_ptrArrayItem.RemoveAll();
}

CWndSMSRecvList::USER_ITEM_INFO* CWndSMSRecvList::AllocUserMgrItem( CString strName, CString strID, CString strTelNum )
{
	USER_ITEM_INFO* pUserItemInfo = new USER_ITEM_INFO;
	if (!pUserItemInfo)
		return NULL;
	pUserItemInfo->strName = strName;
	pUserItemInfo->strID = strID;
	pUserItemInfo->strTelNum = strTelNum;
	pUserItemInfo->nIndex = m_ptrArrayItem.GetSize() + 1;

	return pUserItemInfo;
}

void CWndSMSRecvList::AddUserMgrItem( CString strID, CString strName, CString strTelNum )
{
	USER_ITEM_INFO* pUserItemInfo = NULL;
	pUserItemInfo = AllocUserMgrItem(strName, strID, strTelNum);
	if (!pUserItemInfo)
		return;
	USER_ITEM_INFO* pUserItemInfoLast = NULL;

	if (m_ptrArrayItem.GetSize() > 0)
		pUserItemInfoLast = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(m_ptrArrayItem.GetSize() - 1);
	
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);

	int nDeleteImgWidth = 0, nDeleteImgHeight = 0;
	if (m_pImgDelete)
	{
		nDeleteImgWidth = m_pImgDelete->GetWidth();
		nDeleteImgHeight = m_pImgDelete->GetHeight();
	}


	pUserItemInfo->rtItem.SetRect(WND_SMSRECV_LIST_ITEM_POSITION_X, WND_SMSRECV_LIST_ITME_START_Y,
		WND_SMSRECV_LIST_ITEM_POSITION_X + WND_SMSRECV_LIST_ITEM_POSITION_WIDTH, WND_SMSRECV_LIST_ITME_START_Y + WND_SMSRECV_LIST_ITEM_HEIGHT);

	if (pUserItemInfoLast)
	{
		pUserItemInfo->rtItem.top = pUserItemInfoLast->rtItem.bottom + WND_SMSRECV_LIST_ITEM_Y_GAP ;
		pUserItemInfo->rtItem.bottom = pUserItemInfo->rtItem.top + WND_SMSRECV_LIST_ITEM_HEIGHT ;
	}
	pUserItemInfo->rtName = pUserItemInfo->rtItem;
	pUserItemInfo->rtDelete = pUserItemInfo->rtItem;
	pUserItemInfo->rtDelete.left = pUserItemInfo->rtItem.right - nDeleteImgWidth;
	//pUserItemInfo->rtDelete.top += ((pUserItemInfo->rtItem.Height() - nDeleteImgWidth) / 2);
	//pUserItemInfo->rtDelete.bottom = pUserItemInfo->rtDelete.top + nDeleteImgWidth;
	
	m_ptrArrayItem.Add(pUserItemInfo);
	UpdateScrollInfo();
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CWndSMSRecvList::SortUserItemList()
{

	USER_ITEM_INFO* pUserItemInfo = NULL, *pUserItemInfoLast= NULL;
	//if (m_ptrArrayItem.GetSize() > 0)
	//	pUserItemInfoLast = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(m_ptrArrayItem.GetSize() - 1);
	int nDeleteImgWidth = 0, nDeleteImgHeight = 0;
	if (m_pImgDelete)
	{
		nDeleteImgWidth = m_pImgDelete->GetWidth();
		nDeleteImgHeight = m_pImgDelete->GetHeight();
	}

	for (int i = 0; i < m_ptrArrayItem.GetSize(); i++)
	{
		pUserItemInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pUserItemInfo)
			continue;


		pUserItemInfo->rtItem.SetRect(WND_SMSRECV_LIST_ITEM_POSITION_X,WND_SMSRECV_LIST_ITME_START_Y,
			WND_SMSRECV_LIST_ITEM_POSITION_X + WND_SMSRECV_LIST_ITEM_POSITION_WIDTH, WND_SMSRECV_LIST_ITME_START_Y + WND_SMSRECV_LIST_ITEM_HEIGHT);

		if (pUserItemInfoLast)
		{
			pUserItemInfo->rtItem.top = pUserItemInfoLast->rtItem.bottom + WND_SMSRECV_LIST_ITME_START_Y ;
			pUserItemInfo->rtItem.bottom = pUserItemInfo->rtItem.top + WND_SMSRECV_LIST_ITEM_HEIGHT ;
		}
		pUserItemInfo->rtName = pUserItemInfo->rtItem;
		pUserItemInfo->rtDelete = pUserItemInfo->rtItem;
		pUserItemInfo->rtDelete.left = pUserItemInfo->rtItem.right - nDeleteImgWidth;
		pUserItemInfo->rtDelete.top += ((pUserItemInfo->rtItem.Height() - nDeleteImgWidth) / 2);
		pUserItemInfo->rtDelete.bottom = pUserItemInfo->rtDelete.top + nDeleteImgWidth;
		pUserItemInfo->nIndex = i + 1;

		pUserItemInfoLast = pUserItemInfo;
	}
	UpdateScrollInfo();
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);


}
void CWndSMSRecvList::DeleteUserMgrItem( USER_ITEM_INFO* pUMInfoDel )
{
	int nCntItem = m_ptrArrayItem.GetCount();
	USER_ITEM_INFO* pUMInfo = NULL;
	for (int i = 0; i < nCntItem; i++)
	{
		pUMInfo = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pUMInfo)
			continue;

		if (pUMInfo == pUMInfoDel)
		{
			delete pUMInfo;
			m_ptrArrayItem.RemoveAt(i);
			break;
		}
	}
	SortUserItemList();

}

void CWndSMSRecvList::UpdateWndInfo( USER_ITEM_INFO* pUMInfo )
{

}

void CWndSMSRecvList::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
	if (m_wndScrollBar.GetSafeHwnd())
	{

		CRect rcClient(0, 0, 0, 0);
		GetClientRect(rcClient);
		int nScrollBarWidth = GetSystemMetrics(SM_CXVSCROLL);
		CRect rcWndScrollBar(0, 0, 0, 0);

		rcWndScrollBar.SetRect(rcClient.right - nScrollBarWidth + 1, rcClient.top +1,
			rcClient.right -1, rcClient.bottom - 1);

		m_wndScrollBar.MoveWindow(&rcWndScrollBar);
		
		m_nScrollPageSize = rcClient.Height() - 2;
	}
	UpdateScrollInfo();

}
BOOL CWndSMSRecvList::ScrollItem(int nDiff)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);
	if (nDiff == 0)
		return FALSE;

	USER_ITEM_INFO* pChItem = NULL, *pChItemFirst = NULL, *pChItemLast = NULL;

	int nCntItem = m_ptrArrayItem.GetCount();
	if (nCntItem <= 0)
		return FALSE;

	pChItemFirst = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(0);
	if (!pChItemFirst)
		return FALSE;

	pChItemLast = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(nCntItem - 1);
	if (!pChItemLast)
		return FALSE;

	int nAdjustDiff = 0;

	if (nDiff > 0)	//  ũ
	{
		if (pChItemFirst->rtItem.top >= 0)	// ̻ ũ ø  
			return FALSE;

		nAdjustDiff = nDiff - abs(pChItemFirst->rtItem.top);
		if (nAdjustDiff > 0)
			nDiff = abs(pChItemFirst->rtItem.top);
	}
	else			// Ʒ ũ
	{
		if (pChItemLast->rtItem.bottom <= rcClient.Height())
			return FALSE;

		nAdjustDiff = abs(nDiff) - abs(pChItemLast->rtItem.bottom - rcClient.Height());
		if (nAdjustDiff > 0)
			nDiff = abs(pChItemLast->rtItem.bottom - rcClient.Height()) * (-1);
	}

	for (int i = 0; i < nCntItem; i++)
	{
		pChItem = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(i);
		if (!pChItem)
			continue;


		pChItem->rtItem.OffsetRect(0, nDiff);
		pChItem->rtName.OffsetRect(0, nDiff);
		pChItem->rtDelete.OffsetRect(0, nDiff);


	}


	return TRUE;
}
void CWndSMSRecvList::UpdateScrollInfo()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);
	USER_ITEM_INFO* pChItem = NULL, *pChItemFirst = NULL, *pChItemLast = NULL;

	m_nScrollPageSize = rcClient.Height();

	int nCntItem = m_ptrArrayItem.GetCount();
	if (nCntItem <= 0)
		return;

	pChItemFirst = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(0);
	if (!pChItemFirst)
		return;

	pChItemLast = (USER_ITEM_INFO*)m_ptrArrayItem.GetAt(nCntItem - 1);
	if (!pChItemLast)
		return;

	int nWndHeight = rcClient.Height();
	int nItemHeight = pChItemLast->rtItem.bottom - pChItemFirst->rtItem.top;

	if (nItemHeight > nWndHeight)
	{
		m_wndScrollBar.ShowScrollBar(TRUE);

			if (pChItemLast->rtItem.bottom <= nWndHeight)
			m_bScrollEndReached = TRUE;
		else
			m_bScrollEndReached = FALSE;

	}
	else
	{
		m_wndScrollBar.ShowScrollBar(FALSE);
	}

	m_wndScrollBar.SetScrollRange(0, nItemHeight);
	m_wndScrollBar.SetScrollPos(abs(pChItemFirst->rtItem.top));

	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	si.nMin = 0;
	si.nMax = nItemHeight;
	si.nPage = nWndHeight;
	si.nPos = abs(pChItemFirst->rtItem.top);
	si.nTrackPos = si.nPos;
	m_wndScrollBar.SetScrollInfo(&si);
}

void CWndSMSRecvList::DoScroll(long lScrollValue )
{
	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	}
}

BOOL CWndSMSRecvList::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	long lScrollValue = m_nScrollOneSize * zDelta / 120;
	DoScroll(lScrollValue);
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

void CWndSMSRecvList::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
		long lScrollValue = 0;

	switch (nSBCode)
	{
	case SB_TOP:
	case SB_LINEUP:
		{
			lScrollValue = m_nScrollOneSize * (1);
		}
		break;
	case SB_BOTTOM:
	case SB_LINEDOWN:
		{
			lScrollValue = m_nScrollOneSize * (-1);
		}
		break;
	case SB_PAGEUP:
		{
			lScrollValue = m_nScrollPageSize * (1);
		}
		break;
	case SB_PAGEDOWN:
		{
			lScrollValue = m_nScrollPageSize * (-1);
		}
		break;
	case SB_THUMBTRACK:
		{
			int nCurPos = m_wndScrollBar.GetScrollPos();

			SCROLLINFO si = {0};
			si.cbSize = sizeof(SCROLLINFO);
			si.fMask = SIF_TRACKPOS;
			m_wndScrollBar.GetScrollInfo(&si, SIF_TRACKPOS);

			/* However, because the SetScrollInfo, SetScrollPos, SetScrollRange, GetScrollInfo, 
			GetScrollPos, and GetScrollRange functions support 32-bit scroll bar position data, 
			there is a way to circumvent the 16-bit barrier of the WM_HSCROLL and WM_VSCROLL 
			messages. See GetScrollInfo for a description of the technique. */
			
			// Windows  nPos 32,767 Ѱ. 
			//  ̻   ޽ ũ   Ƿ ޽ nPos ſ ׳ Ʈ  .
			lScrollValue = nCurPos - si.nTrackPos;
		}
		break;
	}
	DoScroll(lScrollValue );

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

LRESULT CWndSMSRecvList::OnAddUser( WPARAM wParam, LPARAM lParam )
{
	CNtalkDragData* pNDD = (CNtalkDragData*)lParam;
	if (!pNDD)
		return 1L;

	AddUserMgrItem(pNDD->m_strID, pNDD->m_strName, pNDD->m_strCellphone );

	return 0L;
}

LRESULT CWndSMSRecvList::OnAddFail( WPARAM wParam, LPARAM lParam )
{
	CWnd* pWndParent = GetParent();
	CNtalkDragData* pNDD = (CNtalkDragData*)lParam;
	if (!pNDD)
		return 1L;

	//CString strErrMsg;
	//strErrMsg.Format(LoadStringFromResource(IDS_STRING562),pNDD->m_strName,pNDD->m_strName);
	//NMessageBox(pWndParent,strErrMsg);
	return 0L;
}
